#include <stdio.h>
#include <stdlib.h> // srand(), rand()
#include <time.h>   // time()

#define N 10

void sisestus(int[]);
void sort(int[]);
void v2ljastus(int[], const char);

int main(void){
	int arr[N];
	sisestus(arr);
	v2ljastus(arr, 'o'); // orginaal jada
	sort(arr);
	v2ljastus(arr, 'a'); // kasvav
	v2ljastus(arr, 'd'); // kahanev
	return 0;
}

void sisestus(int arr[]){
	srand(time(NULL)); // juhuarvu genereerimiseks vajaliku seemne loomine
	                   // time(NULL) annab hetke aja
	int i;
	for(i=0;i<N;i++){
		arr[i] = rand() % 100; // rand() tagastab suure suvalise arvu
		                       // seda arvu jagatakse 100-ga ja jk
		                       // sisestatakse meile jadasse 
	}
}

void sort(int arr[]){
	int i, j, sorted = 0;
	for(i=0;i<N-1 && !sorted;i++){
		sorted = 1;
		for(j=0;j<N-i-1;j++){
			if(arr[j] < arr[j+1]){            //  5    7
				arr[j] += arr[j+1];           //  5 +  7 = 12
				arr[j+1] = arr[j] - arr[j+1]; // 12 -  7 =  5
				arr[j] -= arr[j+1];           // 12 -  5 =  7
				sorted = 0;
			}
		}
		if(sorted)
			printf("Rida juba sorteeritud, lahkun funktsioonist\n");
	}
}

void v2ljastus(int arr[], const char c){
	int i, j, k;
	switch(c){
		case 'o':
			printf("Algne jada            : ");
			i = 0; j = N; k = 1;
			break;
		case 'a':
			printf("Sorteeritud kasvavalt : ");
			i = N - 1; j = -1; k = -1;
			break;
		case 'd':
			printf("Sorteeritud kahanevalt: ");
			i = 0; j = N; k = 1;
			break;
	}
	for(;i!=j;i+=k){ // for(i=0;i<N;i++) || for(i=N;i>0;i++)
		printf("%d ", arr[i]);
	}
	printf("\n");
}
